// Person.cpp: implementation of the Person class.
//
//////////////////////////////////////////////////////////////////////

#include "Person.h"
#include <iostream>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Person::Person(string fnarg, string lnarg, int agearg, double ssarg)
{
this->firstName = fnarg;
this->lastName = lnarg;
this->age = agearg;
shoeSize = ssarg;  // Note: we didn't really NEED "this->", but I like to use it
		// in teaching to make clear that we're modifying an instance variable of
		// a particular object, to wit "this", the object on which the current method was called.
}

Person::~Person()
{

}

int Person::birthday (void)
{
return ++(this->age);
}

// Definition of overloaded << operator.  Since the operator was declared OUTSIDE the class,
// it can't get at the private instance variables firstName, lastName, etc.
// So we have the operator invoke a "put" method, which belongs to the class and
// therefore has access to those variables.
ostream& operator<< (ostream&s, const Person&p)
{
return p.put(s);
}

//
ostream& Person::put (ostream& s) const
{
return s << firstName << " " << lastName << ", age " << age <<
   ", wears size " << shoeSize << " shoes.";
}
