// Pet.cpp: implementation of the Pet class.
//
//////////////////////////////////////////////////////////////////////

#include "Pet.h"
#include <sstream>
using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Pet::Pet(float weightarg, int agearg)
: weight(weightarg), age(agearg)
{

}

Pet::~Pet()
{

}

float Pet::getWeight (void) const
{
	return this->weight;
}

int Pet::getAge (void) const
{
	return this->age;
}

int Pet::birthday (void)
{
	return ++(this->age);
}

bool Pet::fitsInCage (float cageCapacity) const
{
	return this->weight <= cageCapacity;
}

string Pet::basicDescription (void) const
{
	ostringstream result;
	result << "A " << this->petType() << " " << this->getAge() << " years old and weighing " <<
		this->getWeight() << " pounds.  Says \"" << this->sound() <<"\"";
	if (this->canFly())
		result << " Can fly.";
	return result.str();
}


string Pet::description (void) const
{
	return this->basicDescription();  // default; may override
}
